diff --git a/src/backend/crypto/kmgr.c b/src/backend/crypto/kmgr.c
new file mode 100644
index ...410789f
*** a/src/backend/crypto/kmgr.c
--- b/src/backend/crypto/kmgr.c
***************
*** 0 ****
--- 1,461 ----
+ /*-------------------------------------------------------------------------
+  *
+  * kmgr.c
+  *	 Key manager routines
+  *
+  * Key manager is enabled if user requests during initdb.  During bootstrap,
+  * we generate internal keys, wrap them with KEK which is derived from the
+  * user-provided passphrase, and store them into each file located at KMGR_DIR.
+  * Once generated, these are not changed.  During startup, we decrypt all
+  * internal keys and load them to the shared memory space.  Internal keys on
+  * the shared memory are read-only.  All wrapping and unwrapping key routines
+  * depends on openssl library for now.
+  *
+  * Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * IDENTIFICATION
+  *	  src/backend/crypto/kmgr.c
+  *-------------------------------------------------------------------------
+  */
+ 
+ #include "postgres.h"
+ 
+ #include <sys/stat.h>
+ #include <unistd.h>
+ 
+ #include "funcapi.h"
+ #include "miscadmin.h"
+ #include "pgstat.h"
+ 
+ #include "common/sha2.h"
+ #include "common/kmgr_utils.h"
+ #include "crypto/kmgr.h"
+ #include "storage/fd.h"
+ #include "storage/ipc.h"
+ #include "storage/shmem.h"
+ #include "utils/builtins.h"
+ #include "utils/guc.h"
+ #include "utils/memutils.h"
+ 
+ /* Struct stores internal keys in plaintext format */
+ typedef struct KmgrShmemData
+ {
+ 	/*
+ 	 * Internal cryptographic keys. Keys are stored at its ID'th.
+ 	 */
+ 	CryptoKey	intlKeys[KMGR_MAX_INTERNAL_KEYS];
+ } KmgrShmemData;
+ static KmgrShmemData *KmgrShmem;
+ 
+ /*
+  * Key lengths in bytes of internal keys.
+  *
+  * No key supported for now.
+  */
+ static int internalKeyLengths[KMGR_MAX_INTERNAL_KEYS];
+ 
+ /* GUC variables */
+ bool		key_management_enabled = false;;
+ char	   *cluster_passphrase_command = NULL;
+ 
+ static void KmgrSaveCryptoKeys(const char *dir, CryptoKey *keys);
+ static CryptoKey *generate_crypto_key(int len);
+ static void recoverIncompleteRotation(void);
+ 
+ /*
+  * This function must be called ONCE on system install.
+  */
+ void
+ BootStrapKmgr(void)
+ {
+ 	PgKeyWrapCtx	*ctx;
+ 	CryptoKey	keys_wrap[KMGR_MAX_INTERNAL_KEYS];
+ 	char		passphrase[KMGR_MAX_PASSPHRASE_LEN];
+ 	uint8		kekenc[KMGR_ENC_KEY_LEN];
+ 	uint8		kekhmac[KMGR_MAC_KEY_LEN];
+ 	int			passlen;
+ 
+ 	/*
+ 	 * Requirement check. We need openssl library to enable key management
+ 	 * because all encryption and decryption calls happen via openssl function
+ 	 * calls.
+ 	 */
+ #ifndef USE_OPENSSL
+ 	ereport(ERROR,
+ 			(errcode(ERRCODE_CONFIG_FILE_ERROR),
+ 			 (errmsg("cluster encryption is not supported because OpenSSL is not supported by this build"),
+ 			  errhint("Compile with --with-openssl to use cluster encryption."))));
+ #endif
+ 
+ 	memset(keys_wrap, 0, sizeof(keys_wrap));
+ 
+ 	/* Get key encryption key from the passphrase command */
+ 	passlen = kmgr_run_cluster_passphrase_command(cluster_passphrase_command,
+ 												  passphrase, KMGR_MAX_PASSPHRASE_LEN);
+ 	if (passlen < KMGR_MIN_PASSPHRASE_LEN)
+ 		ereport(ERROR,
+ 				(errmsg("passphrase must be more than %d bytes",
+ 						KMGR_MIN_PASSPHRASE_LEN)));
+ 
+ 	/* Get key encryption key and HMAC key from passphrase */
+ 	kmgr_derive_keys(passphrase, passlen, kekenc, kekhmac);
+ 
+ 	/* Create temporarily key wrap context */
+ 	ctx = pg_create_keywrap_ctx(kekenc, kekhmac);
+ 	if (!ctx)
+ 		elog(ERROR, "could not initialize encryption contect");
+ 
+ 	/* Wrap all internal keys by key encryption key */
+ 	for (int id = 0; id < KMGR_MAX_INTERNAL_KEYS; id++)
+ 	{
+ 		CryptoKey *key;
+ 
+ 		/* generate an internal key */
+ 		key = generate_crypto_key(internalKeyLengths[id]);
+ 
+ 		if (!kmgr_wrap_key(ctx, key, &(keys_wrap[id])))
+ 		{
+ 			pg_free_keywrap_ctx(ctx);
+ 			elog(ERROR, "failed to wrap cluster encryption key");
+ 		}
+ 	}
+ 
+ 	/* Save internal keys to the disk */
+ 	KmgrSaveCryptoKeys(KMGR_DIR, keys_wrap);
+ 
+ 	pg_free_keywrap_ctx(ctx);
+ }
+ 
+ /* Report shared-memory space needed by KmgrShmem */
+ Size
+ KmgrShmemSize(void)
+ {
+ 	if (!key_management_enabled)
+ 		return 0;
+ 
+ 	return MAXALIGN(sizeof(KmgrShmemData));
+ }
+ 
+ /* Allocate and initialize key manager memory */
+ void
+ KmgrShmemInit(void)
+ {
+ 	bool	found;
+ 
+ 	if (!key_management_enabled)
+ 		return;
+ 
+ 	KmgrShmem = (KmgrShmemData *) ShmemInitStruct("Key manager",
+ 												  KmgrShmemSize(), &found);
+ 
+ 	if (!found)
+ 		memset(KmgrShmem, 0, KmgrShmemSize());
+ }
+ 
+ /*
+  * Get encryption key passphrase and verify it, then get the internal keys.
+  * This function is called by postmaster at startup time.
+  */
+ void
+ InitializeKmgr(void)
+ {
+ 	CryptoKey	*keys_wrap;
+ 	char		passphrase[KMGR_MAX_PASSPHRASE_LEN];
+ 	int			passlen;
+ 	int			nkeys;
+ 
+ 	if (!key_management_enabled)
+ 		return;
+ 
+ 	elog(DEBUG1, "starting up key management system");
+ 
+ 	/* Recover the failure of the last passphrase rotation if necessary */
+ 	recoverIncompleteRotation();
+ 
+ 	/* Get the crypto keys from the file */
+ 	keys_wrap = kmgr_get_cryptokeys(KMGR_DIR, &nkeys);
+ 	Assert(nkeys == KMGR_MAX_INTERNAL_KEYS);
+ 
+ 	/* Get cluster passphrase */
+ 	passlen = kmgr_run_cluster_passphrase_command(cluster_passphrase_command,
+ 												  passphrase, KMGR_MAX_PASSPHRASE_LEN);
+ 
+ 	/*
+ 	 * Verify passphrase and prepare an internal key in plaintext on shared memory.
+ 	 *
+ 	 * XXX: do we need to prevent internal keys from being swapped out using
+ 	 * mlock?
+ 	 */
+ 	if (!kmgr_verify_passphrase(passphrase, passlen, keys_wrap, KmgrShmem->intlKeys,
+ 								KMGR_MAX_INTERNAL_KEYS))
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+ 				 errmsg("cluster passphrase does not match expected passphrase")));
+ }
+ 
+ const CryptoKey *
+ KmgrGetKey(int id)
+ {
+ 	Assert(id < KMGR_MAX_INTERNAL_KEYS);
+ 
+ 	return (const CryptoKey *) &(KmgrShmem->intlKeys[id]);
+ }
+ 
+ /* Generate an empty CryptoKey */
+ static CryptoKey *
+ generate_crypto_key(int len)
+ {
+ 	CryptoKey *newkey;
+ 
+ 	Assert(len < KMGR_MAX_KEY_LEN);
+ 	newkey = (CryptoKey *) palloc0(sizeof(CryptoKey));
+ 
+ 	if (!pg_strong_random(newkey->key, len))
+ 		elog(ERROR, "failed to generate new crypto key");
+ 
+ 	newkey->klen = len;
+ 
+ 	return newkey;
+ }
+ 
+ /*
+  * Save the given crypto keys to the disk. We don't need CRC check for crypto
+  * keys because these keys have HMAC which is used for integrity check
+  * during unwrapping.
+  */
+ static void
+ KmgrSaveCryptoKeys(const char *dir, CryptoKey *keys)
+ {
+ 	elog(DEBUG2, "saving all cryptographic keys");
+ 
+ 	for (int i = 0; i < KMGR_MAX_INTERNAL_KEYS; i++)
+ 	{
+ 		int			fd;
+ 		char		path[MAXPGPATH];
+ 
+ 		CryptoKeyFilePath(path, dir, i);
+ 
+ 		if ((fd = BasicOpenFile(path, O_RDWR | O_CREAT | O_EXCL | PG_BINARY)) < 0)
+ 			ereport(ERROR,
+ 					(errcode_for_file_access(),
+ 					 errmsg("could not open file \"%s\": %m",
+ 							path)));
+ 
+ 		errno = 0;
+ 		pgstat_report_wait_start(WAIT_EVENT_KEY_FILE_WRITE);
+ 		if (write(fd, &(keys[i]), sizeof(CryptoKey)) != sizeof(CryptoKey))
+ 		{
+ 			/* if write didn't set errno, assume problem is no disk space */
+ 			if (errno == 0)
+ 				errno = ENOSPC;
+ 
+ 			ereport(ERROR,
+ 					(errcode_for_file_access(),
+ 					 errmsg("could not write file \"%s\": %m",
+ 							path)));
+ 		}
+ 		pgstat_report_wait_end();
+ 
+ 		pgstat_report_wait_start(WAIT_EVENT_KEY_FILE_SYNC);
+ 		if (pg_fsync(fd) != 0)
+ 			ereport(PANIC,
+ 					(errcode_for_file_access(),
+ 					 errmsg("could not fsync file \"%s\": %m",
+ 							path)));
+ 		pgstat_report_wait_end();
+ 
+ 		if (close(fd) != 0)
+ 			ereport(ERROR,
+ 					(errcode_for_file_access(),
+ 					 errmsg("could not close file \"%s\": %m",
+ 							path)));
+ 	}
+ }
+ 
+ 
+ /*
+  * Check the last passphrase rotation was completed. If not, we decide which wrapped
+  * keys will be used according to the status of temporary directory and its wrapped
+  * keys.
+  */
+ static void
+ recoverIncompleteRotation(void)
+ {
+ 	struct stat st;
+ 	struct stat st_tmp;
+ 	CryptoKey *keys;
+ 	int			nkeys_tmp;
+ 
+ 	/* The cluster passphrase rotation was completed, nothing to do */
+ 	if (stat(KMGR_TMP_DIR, &st_tmp) != 0)
+ 		return;
+ 
+ 	/*
+ 	 * If there is only temporary directory, it means that the previous
+ 	 * rotation failed after wrapping the all internal keys by the new
+ 	 * passphrase.  Therefore we use the new cluster passphrase.
+ 	 */
+ 	if (stat(KMGR_DIR, &st) != 0)
+ 	{
+ 		ereport(DEBUG1,
+ 				(errmsg("there is only temporary directory, use the newly wrapped keys")));
+ 
+ 		if (rename(KMGR_TMP_DIR, KMGR_DIR) != 0)
+ 			ereport(ERROR,
+ 					errmsg("could not rename directory \"%s\" to \"%s\": %m",
+ 						   KMGR_TMP_DIR, KMGR_DIR));
+ 		ereport(LOG,
+ 				errmsg("cryptographic keys wrapped by new passphrase command are chosen"),
+ 				errdetail("last cluster passphrase rotation failed in the middle"));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * In case where both the original directory and temporary directory
+ 	 * exist, there are two possibilities: (a) the all internal keys are
+ 	 * wrapped by the new passphrase but rotation failed before removing the
+ 	 * original directory, or (b) the rotation failed during wrapping internal
+ 	 * keys by the new passphrase.  In case of (a) we need to use the wrapped
+ 	 * keys in the temporary directory as rotation is essentially completed,
+ 	 * but in case of (b) we use the wrapped keys in the original directory.
+ 	 *
+ 	 * To check the possibility of (b) we validate the wrapped keys in the
+ 	 * temporary directory by checking the number of wrapped keys.  Since the
+ 	 * wrapped key length is smaller than one disk sector, which is 512 bytes
+ 	 * on common hardware, saving wrapped key is atomic write. So we can
+ 	 * ensure that the all wrapped keys are valid if the number of wrapped
+ 	 * keys in the temporary directory is KMGR_MAX_INTERNAL_KEYS.
+ 	 */
+ 	keys = kmgr_get_cryptokeys(KMGR_TMP_DIR, &nkeys_tmp);
+ 
+ 	if (nkeys_tmp == KMGR_MAX_INTERNAL_KEYS)
+ 	{
+ 		/*
+ 		 * This is case (a), the all wrapped keys in temporary directory are
+ 		 * valid. Remove the original directory and rename.
+ 		 */
+ 		ereport(DEBUG1,
+ 				(errmsg("last passphrase rotation failed before renaming direcotry name, use the newly wrapped keys")));
+ 
+ 		if (!rmtree(KMGR_DIR, true))
+ 			ereport(ERROR,
+ 					(errmsg("could not remove directory \"%s\"",
+ 							KMGR_DIR)));
+ 		if (rename(KMGR_TMP_DIR, KMGR_DIR) != 0)
+ 			ereport(ERROR,
+ 					errmsg("could not rename directory \"%s\" to \"%s\": %m",
+ 						   KMGR_TMP_DIR, KMGR_DIR));
+ 
+ 		ereport(LOG,
+ 				errmsg("cryptographic keys wrapped by new passphrase command are chosen"),
+ 				errdetail("last cluster passphrase rotation failed in the middle"));
+ 	}
+ 	else
+ 	{
+ 		/*
+ 		 * This is case (b), the last passphrase rotation failed during
+ 		 * wrapping keys. Remove the keys in the temporary directory and use
+ 		 * keys in the original keys.
+ 		 */
+ 		ereport(DEBUG1,
+ 				(errmsg("last passphrase rotation failed during wrapping keys, use the old wrapped keys")));
+ 
+ 		if (!rmtree(KMGR_TMP_DIR, true))
+ 			ereport(ERROR,
+ 					(errmsg("could not remove directory \"%s\"",
+ 							KMGR_DIR)));
+ 		ereport(LOG,
+ 				errmsg("cryptographic keys wrapped by old passphrase command are chosen"),
+ 				errdetail("last cluster passphrase rotation failed in the middle"));
+ 	}
+ 
+ 	pfree(keys);
+ }
+ 
+ /*
+  * SQL function to rotate the cluster passphrase. This function assumes that
+  * the cluster_passphrase_command is already reloaded to the new value.
+  * All internal keys are wrapped by the new passphrase and saved to the disk.
+  * To update all crypto keys atomically we save the newly wrapped keys to the
+  * temporary directory, pg_cryptokeys_tmp, and remove the original directory,
+  * pg_cryptokeys, and rename it. These operation is performed without the help
+  * of WAL.  In the case of failure during rotationpg_cryptokeys directory and
+  * pg_cryptokeys_tmp directory can be left in incomplete status.  We recover
+  * the incomplete situation by checkIncompleteRotation.
+  */
+ Datum
+ pg_rotate_cluster_passphrase(PG_FUNCTION_ARGS)
+ {
+ 	PgKeyWrapCtx	*ctx;
+ 	CryptoKey	newkeys[KMGR_MAX_INTERNAL_KEYS];
+ 	char		passphrase[KMGR_MAX_PASSPHRASE_LEN];
+ 	uint8		new_kekenc[KMGR_ENC_KEY_LEN];
+ 	uint8		new_kekhmac[KMGR_MAC_KEY_LEN];
+ 	int			passlen;
+ 
+ 	if (!key_management_enabled)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 				 errmsg("could not rotate cluster passphrase because key management is not supported")));
+ 
+ 	memset(newkeys, 0, sizeof(newkeys));
+ 
+ 	/* Recover the failure of the last passphrase rotation if necessary */
+ 	recoverIncompleteRotation();
+ 
+ 	/*
+ 	 * I think this has to be done from a stand-alone backend since the
+ 	 * file descriptor was already closed.
+ 	 */
+ 	passlen = kmgr_run_cluster_passphrase_command(cluster_passphrase_command,
+ 												  passphrase,
+ 												  KMGR_MAX_PASSPHRASE_LEN);
+ 	if (passlen < KMGR_MIN_PASSPHRASE_LEN)
+ 		ereport(ERROR,
+ 				(errmsg("passphrase must be more than %d bytes",
+ 						KMGR_MIN_PASSPHRASE_LEN)));
+ 
+ 	/* Get new key encryption key and encryption context */
+ 	kmgr_derive_keys(passphrase, passlen, new_kekenc, new_kekhmac);
+ 	ctx = pg_create_keywrap_ctx(new_kekenc, new_kekhmac);
+ 	if (!ctx)
+ 		elog(ERROR, "could not initialize encryption contect");
+ 
+ 	for (int id = 0; id < KMGR_MAX_INTERNAL_KEYS; id++)
+ 	{
+ 		if (!kmgr_wrap_key(ctx, &(KmgrShmem->intlKeys[id]), &(newkeys[id])))
+ 			elog(ERROR, "failed to wrap key");
+ 	}
+ 
+ 	/* Create temporary directory */
+ 	if (MakePGDirectory(KMGR_TMP_DIR) < 0)
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("could not create temporary directory \"%s\": %m",
+ 						KMGR_TMP_DIR)));
+ 	fsync_fname(KMGR_TMP_DIR, true);
+ 
+ 	/* Prevent concurrent key rotation */
+ 	LWLockAcquire(KmgrFileLock, LW_EXCLUSIVE);
+ 
+ 	/* Save the key wrapped by the new passphrase to the temporary directory */
+ 	KmgrSaveCryptoKeys(KMGR_TMP_DIR, newkeys);
+ 
+ 	/* Remove the original directory */
+ 	if (!rmtree(KMGR_DIR, true))
+ 		ereport(ERROR,
+ 				(errmsg("could not remove directory \"%s\"",
+ 						KMGR_DIR)));
+ 
+ 	/* Rename to the original directory */
+ 	if (rename(KMGR_TMP_DIR, KMGR_DIR) != 0)
+ 		ereport(ERROR,
+ 				(errmsg("could not rename directory \"%s\" to \"%s\": %m",
+ 						KMGR_TMP_DIR, KMGR_DIR)));
+ 	fsync_fname(KMGR_DIR, true);
+ 
+ 	LWLockRelease(KmgrFileLock);
+ 
+ 	pg_free_keywrap_ctx(ctx);
+ 	PG_RETURN_BOOL(true);
+ }
diff --git a/src/backend/libpq/be-secure-openssl.c b/src/backend/libpq/be-secure-openssl.c
new file mode 100644
index 8b21ff4..744fa96
*** a/src/backend/libpq/be-secure-openssl.c
--- b/src/backend/libpq/be-secure-openssl.c
***************
*** 30,35 ****
--- 30,36 ----
  #endif
  
  #include <openssl/ssl.h>
+ #include <openssl/conf.h>
  #include <openssl/dh.h>
  #include <openssl/conf.h>
  #ifndef OPENSSL_NO_ECDH
diff --git a/src/backend/main/main.c b/src/backend/main/main.c
new file mode 100644
index a4dd233..bd4c2a3
*** a/src/backend/main/main.c
--- b/src/backend/main/main.c
*************** help(const char *progname)
*** 325,330 ****
--- 325,331 ----
  	printf(_("  -N MAX-CONNECT     maximum number of allowed connections\n"));
  	printf(_("  -o OPTIONS         pass \"OPTIONS\" to each server process (obsolete)\n"));
  	printf(_("  -p PORT            port number to listen on\n"));
+ 	printf(_("  -R fd              allow password to be read from numeric file descriptor\n"));
  	printf(_("  -s                 show statistics after each query\n"));
  	printf(_("  -S WORK-MEM        set amount of memory for sorts (in kB)\n"));
  	printf(_("  -V, --version      output version information, then exit\n"));
diff --git a/src/backend/postmaster/pgstat.c b/src/backend/postmaster/pgstat.c
new file mode 100644
index 822f0eb..a1faea7
*** a/src/backend/postmaster/pgstat.c
--- b/src/backend/postmaster/pgstat.c
*************** pgstat_get_wait_io(WaitEventIO w)
*** 4134,4139 ****
--- 4134,4148 ----
  		case WAIT_EVENT_DSM_FILL_ZERO_WRITE:
  			event_name = "DSMFillZeroWrite";
  			break;
+ 		case WAIT_EVENT_KEY_FILE_READ:
+ 			event_name = "KeyFileRead";
+ 			break;
+ 		case WAIT_EVENT_KEY_FILE_WRITE:
+ 			event_name = "KeyFileWrite";
+ 			break;
+ 		case WAIT_EVENT_KEY_FILE_SYNC:
+ 			event_name = "KeyFileSync";
+ 			break;
  		case WAIT_EVENT_LOCK_FILE_ADDTODATADIR_READ:
  			event_name = "LockFileAddToDataDirRead";
  			break;
diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
new file mode 100644
index 959e3b8..00c82a7
*** a/src/backend/postmaster/postmaster.c
--- b/src/backend/postmaster/postmaster.c
***************
*** 100,105 ****
--- 100,106 ----
  #include "common/file_perm.h"
  #include "common/ip.h"
  #include "common/string.h"
+ #include "crypto/kmgr.h"
  #include "lib/ilist.h"
  #include "libpq/auth.h"
  #include "libpq/libpq.h"
*************** static int	SendStop = false;
*** 237,242 ****
--- 238,244 ----
  
  /* still more option variables */
  bool		EnableSSL = false;
+ int			terminal_fd = -1;
  
  int			PreAuthDelay = 0;
  int			AuthenticationTimeout = 60;
*************** PostmasterMain(int argc, char *argv[])
*** 694,700 ****
  	 * tcop/postgres.c (the option sets should not conflict) and with the
  	 * common help() function in main/main.c.
  	 */
! 	while ((opt = getopt(argc, argv, "B:bc:C:D:d:EeFf:h:ijk:lN:nOo:Pp:r:S:sTt:W:-:")) != -1)
  	{
  		switch (opt)
  		{
--- 696,702 ----
  	 * tcop/postgres.c (the option sets should not conflict) and with the
  	 * common help() function in main/main.c.
  	 */
! 	while ((opt = getopt(argc, argv, "B:bc:C:D:d:EeFf:h:ijk:lN:nOo:Pp:R:r:S:sTt:W:-:")) != -1)
  	{
  		switch (opt)
  		{
*************** PostmasterMain(int argc, char *argv[])
*** 792,797 ****
--- 794,803 ----
  				/* only used by single-user backend */
  				break;
  
+ 			case 'R':
+ 				terminal_fd = atoi(optarg);
+ 				break;
+ 
  			case 'S':
  				SetConfigOption("work_mem", optarg, PGC_POSTMASTER, PGC_S_ARGV);
  				break;
*************** PostmasterMain(int argc, char *argv[])
*** 1351,1356 ****
--- 1357,1369 ----
  	autovac_init();
  
  	/*
+ 	 * Initialize key manager.
+ 	 */
+ 	InitializeKmgr();
+ 	if (terminal_fd != -1)
+ 		close(terminal_fd);
+ 
+ 	/*
  	 * Load configuration files for client authentication.
  	 */
  	if (!load_hba())
diff --git a/src/backend/replication/basebackup.c b/src/backend/replication/basebackup.c
new file mode 100644
index b89df01..6ad051d
*** a/src/backend/replication/basebackup.c
--- b/src/backend/replication/basebackup.c
***************
*** 18,23 ****
--- 18,24 ----
  
  #include "access/xlog_internal.h"	/* for pg_start/stop_backup */
  #include "catalog/pg_type.h"
+ #include "common/kmgr_utils.h"
  #include "common/file_perm.h"
  #include "commands/progress.h"
  #include "lib/stringinfo.h"
*************** struct exclude_list_item
*** 152,157 ****
--- 153,161 ----
   */
  static const char *const excludeDirContents[] =
  {
+ 	/* Skip temporary crypto key files */
+ 	KMGR_TMP_DIR,
+ 
  	/*
  	 * Skip temporary statistics files. PG_STAT_TMP_DIR must be skipped even
  	 * when stats_temp_directory is set because PGSS_TEXT_FILE is always
diff --git a/src/backend/storage/ipc/ipci.c b/src/backend/storage/ipc/ipci.c
new file mode 100644
index 96c2aaa..64fe10c
*** a/src/backend/storage/ipc/ipci.c
--- b/src/backend/storage/ipc/ipci.c
***************
*** 23,28 ****
--- 23,29 ----
  #include "access/syncscan.h"
  #include "access/twophase.h"
  #include "commands/async.h"
+ #include "crypto/kmgr.h"
  #include "miscadmin.h"
  #include "pgstat.h"
  #include "postmaster/autovacuum.h"
*************** CreateSharedMemoryAndSemaphores(void)
*** 149,154 ****
--- 150,156 ----
  		size = add_size(size, BTreeShmemSize());
  		size = add_size(size, SyncScanShmemSize());
  		size = add_size(size, AsyncShmemSize());
+ 		size = add_size(size, KmgrShmemSize());
  #ifdef EXEC_BACKEND
  		size = add_size(size, ShmemBackendArraySize());
  #endif
*************** CreateSharedMemoryAndSemaphores(void)
*** 267,272 ****
--- 269,275 ----
  	BTreeShmemInit();
  	SyncScanShmemInit();
  	AsyncShmemInit();
+ 	KmgrShmemInit();
  
  #ifdef EXEC_BACKEND
  
diff --git a/src/backend/tcop/postgres.c b/src/backend/tcop/postgres.c
new file mode 100644
index 411cfad..ab464d9
*** a/src/backend/tcop/postgres.c
--- b/src/backend/tcop/postgres.c
***************
*** 42,47 ****
--- 42,48 ----
  #include "catalog/pg_type.h"
  #include "commands/async.h"
  #include "commands/prepare.h"
+ #include "crypto/kmgr.h"
  #include "executor/spi.h"
  #include "jit/jit.h"
  #include "libpq/libpq.h"
*************** process_postgres_switches(int argc, char
*** 3554,3560 ****
  	 * postmaster/postmaster.c (the option sets should not conflict) and with
  	 * the common help() function in main/main.c.
  	 */
! 	while ((flag = getopt(argc, argv, "B:bc:C:D:d:EeFf:h:ijk:lN:nOo:Pp:r:S:sTt:v:W:-:")) != -1)
  	{
  		switch (flag)
  		{
--- 3555,3561 ----
  	 * postmaster/postmaster.c (the option sets should not conflict) and with
  	 * the common help() function in main/main.c.
  	 */
! 	while ((flag = getopt(argc, argv, "B:bc:C:D:d:EeFf:h:ijk:lN:nOo:Pp:R:r:S:sTt:v:W:-:")) != -1)
  	{
  		switch (flag)
  		{
*************** process_postgres_switches(int argc, char
*** 3650,3655 ****
--- 3651,3660 ----
  					strlcpy(OutputFileName, optarg, MAXPGPATH);
  				break;
  
+ 			case 'R':
+ 				terminal_fd = atoi(optarg);
+ 				break;
+ 
  			case 'S':
  				SetConfigOption("work_mem", optarg, ctx, gucsource);
  				break;
*************** PostgresMain(int argc, char *argv[],
*** 3902,3907 ****
--- 3907,3921 ----
  	BaseInit();
  
  	/*
+ 	 * Initialize kmgr for cluster encryption. Since kmgr needs to attach to
+ 	 * shared memory the initialization must be called after BaseInit().
+ 	 */
+ 	if (!IsUnderPostmaster)
+ 		InitializeKmgr();
+ 	if (terminal_fd != -1)
+ 		close(terminal_fd);
+ 
+ 	/*
  	 * Create a per-backend PGPROC struct in shared memory, except in the
  	 * EXEC_BACKEND case where this was done in SubPostmasterMain. We must do
  	 * this before we can use LWLocks (and in the EXEC_BACKEND case we already
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
new file mode 100644
index a62d64e..411f068
*** a/src/backend/utils/misc/guc.c
--- b/src/backend/utils/misc/guc.c
***************
*** 47,52 ****
--- 47,53 ----
  #include "commands/vacuum.h"
  #include "commands/variable.h"
  #include "common/string.h"
+ #include "crypto/kmgr.h"
  #include "funcapi.h"
  #include "jit/jit.h"
  #include "libpq/auth.h"
*************** const char *const config_group_names[] =
*** 745,750 ****
--- 746,753 ----
  	gettext_noop("Statistics / Monitoring"),
  	/* STATS_COLLECTOR */
  	gettext_noop("Statistics / Query and Index Statistics Collector"),
+ 	/* ENCRYPTION */
+ 	gettext_noop("Encryption"),
  	/* AUTOVACUUM */
  	gettext_noop("Autovacuum"),
  	/* CLIENT_CONN */
*************** static struct config_bool ConfigureNames
*** 2036,2041 ****
--- 2039,2055 ----
  		NULL, NULL, NULL
  	},
  
+ 	{
+ 		{"key_management", PGC_INTERNAL, PRESET_OPTIONS,
+ 		 gettext_noop("Show whether key management is enabled for this cluster."),
+ 		 NULL,
+ 		 GUC_NOT_IN_SAMPLE | GUC_DISALLOW_IN_FILE
+ 		},
+ 		&key_management_enabled,
+ 		false,
+ 		NULL, NULL, NULL
+ 	},
+ 
  	/* End-of-list marker */
  	{
  		{NULL, 0, 0, NULL, NULL}, NULL, false, NULL, NULL, NULL
*************** static struct config_string ConfigureNam
*** 4392,4397 ****
--- 4406,4421 ----
  		"",
  		NULL, NULL, NULL
  	},
+ 
+ 	{
+ 		{"cluster_passphrase_command", PGC_SIGHUP, ENCRYPTION,
+ 			gettext_noop("Command to obtain passphrase for database encryption."),
+ 			NULL
+ 		},
+ 		&cluster_passphrase_command,
+ 		"",
+ 		NULL, NULL, NULL
+ 	},
  
  	{
  		{"application_name", PGC_USERSET, LOGGING_WHAT,
diff --git a/src/backend/utils/misc/postgresql.conf.sample b/src/backend/utils/misc/postgresql.conf.sample
new file mode 100644
index 9cb571f..fc30641
*** a/src/backend/utils/misc/postgresql.conf.sample
--- b/src/backend/utils/misc/postgresql.conf.sample
***************
*** 633,638 ****
--- 633,643 ----
  					# autovacuum, -1 means use
  					# vacuum_cost_limit
  
+ #------------------------------------------------------------------------------
+ # ENCRYPTION
+ #------------------------------------------------------------------------------
+ 
+ #cluster_passphrase_command = ''
  
  #------------------------------------------------------------------------------
  # CLIENT CONNECTION DEFAULTS
